import greenfoot.*;  // imports Actor, World, Greenfoot, GreenfootImage

import java.util.Random;
import java.awt.Color;

/**
 * Un monde où un ours mange des feuilles.
 * 
 * @author Bernard Gisin
 * @version 0.1
 */

public class MangeWorld extends World
{
   public int nMaxFeuilles = 5;
   cOurs ours = null;
   RectangleBas rectbas = null;
   
    /**
     * Crée le monde de 8 x 9 cellules.
     * La taille d'une cellule est de 60x60 pixels
     */
    public MangeWorld() 
    {
        super(8, 9, 60);        
        setBackground("cell.jpg");
        
        populate(500);
    }

    public void populate(int nbDeplacement)
    {
        int nn = 0;
        int nX = 0; // coordonnées d'où les feuilles sont placées
        int nY = 0;
        Leaf feuille = null;

        int aanCell[][] = new int[8][8];
        
        // Si le nombre de déplacement est trop grand,
        // n'augmente pas le nombre de feuilles.
        if (((nMaxFeuilles ==  5) && (nbDeplacement > 20)) ||
            ((nMaxFeuilles ==  6) && (nbDeplacement > 17)) ||
            ((nMaxFeuilles ==  7) && (nbDeplacement > 20)) ||
            ((nMaxFeuilles ==  8) && (nbDeplacement > 22)) ||
            ((nMaxFeuilles ==  9) && (nbDeplacement > 21)) ||
            ((nMaxFeuilles == 10) && (nbDeplacement > 29)) ||
            ((nMaxFeuilles >= 11) && (nbDeplacement > 32))) {
           if (ours != null) Greenfoot.playSound("EssayeMieux.wav");
        }
        else {
            // augmente le nombre de feuilles
            Greenfoot.playSound("NiveauSuivant.wav");
            nMaxFeuilles++;
        }
        
        // Place les feuilles sur la grille
        Random rand = new Random(); // initialise le générateur de nombres aléatoires.
        rand.setSeed(13 + nMaxFeuilles); // pour avoir toujours le même placement des feuilles
    
        if (ours != null) removeObject(ours);
        
        ours = new cOurs();
        addObject(ours, 3, 3);
        
        // initialisation du contenu des cellueles
        for (nX=0; nX < 8; nX++) {
            for (nY=0; nY < 8; nY++) {
                aanCell[nX][nY] = 0;
            }
        }
        aanCell[3][3] = 2; // indique que l'ours est ici.
        
        nn = 1;
        while (nn <= nMaxFeuilles) {
            nX = rand.nextInt(8); // coord. pour placer une nouvelle feuille
            nY = rand.nextInt(8);
            
// if (getObjectsAt(nX, nY, Leaf.class) == null) {  A EVITER, PLANTE GreenFoot
            if (aanCell[nX][nY] == 0) {    
                feuille = new Leaf();
                addObject(feuille, nX, nY);
                aanCell[nX][nY] = 1; // indique qu'une feuille a été placée ici.
                nn++;
            }
        }
        
        // Si pas déjà fait, crée le rectangle d'affichage en bas.
        if (rectbas != null) return;
        
        // Pour le fond du compteur
        rectbas = new RectangleBas();
        addObject(rectbas,4,8);
        
        GreenfootImage image = new GreenfootImage(8*60+60, 55);
        image.setColor(new Color(255, 255, 150));
        image.fillRect(0, 0, 8*60+60, 55);
        rectbas.setImage(image);
        
        // Pour le compteur de nombre de déplacement.
        Counter c1 = new Counter();
        addObject(c1, 0, 8);
    }
    
}